uniform sampler2D  u_texture;
uniform sampler2D  u_texture1;

varying lowp  vec3 v_color;
uniform lowp vec3  u_groundColor;
varying highp vec2 v_texcoord;
varying lowp  vec3 v_normal;
varying highp vec2 v_lightCookieUV;

varying lowp float v_lightIntensity;

uniform lowp vec3 u_lightDir;
uniform lowp vec3 u_halfAngle;
const lowp vec3 rimDir		= normalize(vec3(-0.3, 0.15, 0.0));

const lowp vec4 grayScale   = vec4(0.13, 0.15, 0.12, 0.08);

const lowp vec3 rimMaskColor = vec3(0.5, 0.5, 0.5);

void main()
{
	lowp vec4  tex   = texture2D( u_texture, v_texcoord );

	lowp vec3 normal  = normalize(v_normal);	
	lowp float att    = dot(normal, u_lightDir) * 0.5 + 0.5;//wrap light		
	
	lowp float rimAtt = clamp(dot(normal, rimDir), 0.0, 1.0);

	rimAtt *= rimAtt;
	rimAtt *= dot(tex.rgb, rimMaskColor);

	lowp float specMask =  dot(tex, grayScale);
	lowp float spec = pow(clamp(dot(u_halfAngle, normal), 0.0, 1.0), 16.0) * specMask;
	lowp vec3 color = mix(u_groundColor, texture2D( u_texture1, v_lightCookieUV ).rgb  * 1.5, att);

	
	color += vec3(0.8, 0.64, 0.24) * v_lightIntensity;
	
	
	lowp float fresnell = clamp(1.0 - normal.z, 0.0, 1.0);
	fresnell *= fresnell;
	fresnell *= fresnell;
	color += fresnell * 0.5;
	gl_FragColor = vec4(clamp( (color * (spec + tex.rgb * v_color.rgb) + vec3(rimAtt)), vec3(0.0, 0.0, 0.0), vec3(1.0, 1.0, 1.0) ), 1.0);
}